using System.Windows.Forms;
using System.Drawing;
using System;
using System.Runtime.InteropServices;
using Theremino_Script;

public static class Script 
{
	public static void Main(string[] s) 
	{
		if (s.Length > 0)
		{
			switch (s[0])
			{
				case "1":
					InitPictureboxImage();
					Timer1.Interval = 20;
					if (Timer1.Enabled) 
					{
						Timer1.Enabled = false;
						Timer1.Stop();
						Timer1.Tick -= new EventHandler(Timer1_Tick); 
					}
					else 
					{
						Host.GetTextBox.Clear();
						Timer1.Tick += new EventHandler(Timer1_Tick); 
						Timer1.Enabled = true;
						Timer1.Start();
					}
					break;
	
				case "2":
					InitPictureboxImage();
					TestLines();
					break;
	
				case "3":
					MessageBox.Show("HELLO WORLD");
					break;
	
				case "4":
					Host.ShowMessage("GOODBYE");
					//host.textbox.backcolor = RandomColor;
					//  ------------------------------ division by zero
					//int b = 0;
					//b = (17 / b);
					//  ------------------------------ double to integer
					//double d = 12.34;
					//int a = d;
					//  ------------------------------ double to integer
					// r = 12.34
					break;
			}
		}
		else
		{
			MessageBox.Show("This example requires Host.PictureBox and Host.TextBox");
		}
	}




	//  ------------------------------------------------------
	//    TEST LINES and CIRCLES
	//  ------------------------------------------------------

	private static bool TestLinesWorking = false;
	private static bool TestLinesAbort = false;
	private static Timer Timer1 = new Timer();


	private static void InitPictureboxImage()
	{ 
		if (Host.GetPictureBox.Image == null)
		{
			Host.GetPictureBox.Image = new Bitmap( Host.GetPictureBox.Width, Host.GetPictureBox.Height); 
		}
	}

	private static void ClearPicturebox()
	{
		Graphics g = Graphics.FromImage(Host.GetPictureBox.Image); 
		g.Clear(Color.White);
	}


	private static void Timer1_Tick(object sender, System.EventArgs e) 
	{
		Test_Circles();
		//  ------------------------- division by zero
		// dim b as integer = 0
		// b = 17 / b

		//host.TextBox.Text = host.TextBox.Text + "ddddd ";
	}

	private static Random RandomGen = new Random();
	private static float Rnd()
	{
		return (float)(RandomGen.Next(0, 99999) / 100000.0);
	}

	private static void TestLines() 
	{
		if (TestLinesWorking) 
		{
			TestLinesAbort = true;
			return;
		}
		Host.GetTextBox.Clear();
		TestLinesAbort = false;
		TestLinesWorking = true;
		float div;
		float x1 = 0;
		float y1 = 0;
		float x2 = 0;
		float y2 = 0;
		float x3 = 0;
		float y3 = 0;
		float x4 = 0;
		float y4 = 0;
		float dx1 = 0;
		float dx2 = 0;
		float dy1 = 0;
		float dy2 = 0;
		float f;
		float w = Host.GetPictureBox.Width;
		float h = Host.GetPictureBox.Height;
		Graphics g = Graphics.FromImage(Host.GetPictureBox.Image);
		//g.Clear(Color.Red);
		div = 64;
		while (!TestLinesAbort)
		{
			Pen p = new Pen(Color.FromArgb((int)(Rnd() * 255), (int)(Rnd() * 255), (int)(Rnd() * 255)));

			dx1 = (w * Rnd());
			dy1 = (h * Rnd());
			dx2 = (w * Rnd());
			dy2 = (h * Rnd());
			x3 = ((dx1 - x1) / div);
			y3 = ((dy1 - y1) / div);
			x4 = ((dx2 - x2) / div);
			y4 = ((dy2 - y2) / div);
			for (f = 1; f <= 80; f++) 
			{
				x1 = (x1 + x3);
				y1 = (y1 + y3);
				x2 = (x2 + x4);
				y2 = (y2 + y4);
				g.DrawLine(p, x1, y1, x2, y2);
			}
			Host.GetPictureBox.Refresh();
			Application.DoEvents();
		}
		TestLinesWorking = false;
	}

	//  ------------------------------------------------------
	//     Test Circles
	//  ------------------------------------------------------
	private static void Test_Circles() {
		// on error resume next
		Graphics g = Graphics.FromImage(Host.GetPictureBox.Image);
		int r;
		int x;
		int y;
		SolidBrush b;
		int cr;
		int cg;
		int cb;
		for (int i = 1; (i <= 40); i++) 
		{
			r = (int)(20 + (40 * Rnd()));
			x = (int)(250 * Rnd());
			y = (int)(210 * Rnd());
			cr = (int)(50 + (70 * Rnd()));
			cg = (int)(50 + (70 * Rnd()));
			cb = (int)(50 + (70 * Rnd()));

			for (int r2 = r; r2 >= 1; r2 -= 1) 
			{
				b = new SolidBrush(Color.FromArgb(cr, cg, cb));
				g.FillEllipse(b, x - (r2 / 3), y - (r2 / 3), r2, r2);
				cr = Math.Min((cr + 5), 255);
				cg = Math.Min((cg + 4), 255);
				cb = Math.Min((cb + 4), 255);
			}
		}
		Host.GetPictureBox.Refresh();
	}

	private static void DebugShowNumber(float n)
	{
		Host.GetTextBox.Text = Host.GetTextBox.Text + n.ToString() + Environment.NewLine;
	}

}


