' ================================================================================================
'  Theremino System - RobotArmController
' ------------------------------------------------------------------------------------------------
'  - ENG - 
'  This applicazione .....
' ------------------------------------------------------------------------------------------------
'  - ITA - 
'  Questa applicazione invia comandi per caricare, avviare e mettere in pausa i GCode
'  I comandi sono numeri interi e vengono scritti nello slot "GcodeAutomationSlot"
'  -1 = STOP e RIAVVOLGI
'   0 = PAUSA
'   1 = CARICA IL PRIMO FILE GCODE E PARTI
'   2 = CARICA IL SECONDO FILE GCODE E PARTI
'   3 = ....
'  Normalmente questi comandi sono ricevuti dalla applicazione "Theremino ARM"
'  I file GCode devono trovarsi nella cartella "Theremino_Arm\Media\AutomationFiles"
' ================================================================================================

Dim AppName As String = "RobotArmController"

Dim GcodeAutomationSlot As Int32 = 1		' Automation slot		- Slot dove inviare i comandi

Dim FormMaximized As Boolean = False        ' Form maximized        - Finestra a tutto schermo

Dim NumButtons As Int32 = 8 				' Button number			- Numero di comandi
Dim LabelsPerRow As Int32 = 4				' Labels for each row	- Caselle per riga
Dim LabelSizeY As Int32 = 150				' Label SIZE Y			- Altezza delle caselle

Dim ColorON As Color = Color.Orange			    ' Color For ON			
Dim ColorOFF As Color = Color.White			    ' Color For OFF			
Dim ColorPAUSED As Color = Color.Yellow		    ' Color For PAUSED		
Dim ColorBack As Color = Color.AliceBlue	    ' Color For Back		
Dim ColorFormBack As Color = Color.LightGreen   ' Color For Form Back   
Dim ColorText As Color = Color.Black		    ' Color For Text		


' ------------------------------------------------------------------------------------------------
'  Main Loop
' ------------------------------------------------------------------------------------------------
Sub Main(ByVal s() As String)
	If Form1 IsNot Nothing Then Return
	Form1 = New form
	InitializeComponents
	MemoryMappedFile_Init
	WriteSlot(GcodeAutomationSlot, 0)
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(16)
	End While
End Sub

Sub Button1_MouseDown(sender As Object, e As MouseEventArgs) Handles Button1.MouseDown
	ReleaseAllButtons
	WriteSlot(GcodeAutomationSlot, -1)
End Sub

Sub Button2_MouseDown(sender As Object, e As MouseEventArgs) Handles Button2.MouseDown
	WriteSlot(GcodeAutomationSlot, 0)
	End
End Sub



Sub ClickHandler(sender As Object, e As EventArgs)
	Dim l As Label = CType(sender, Label)
	Dim n As Int32 = Array.IndexOf(LabelArray, l)
	Select l.BackColor
		Case ColorON
			l.BackColor = ColorPAUSED
			WriteSlot(GcodeAutomationSlot, 0)
		Case ColorPAUSED
			l.BackColor = ColorON
			WriteSlot(GcodeAutomationSlot, n + 1)
		Case Else
			ReleaseAllButtons
			l.BackColor = ColorON
			WriteSlot(GcodeAutomationSlot, n + 1)
	End Select
End Sub

Sub ReleaseAllButtons
	For Each l As Label In LabelArray
		l.BackColor = ColorOFF
	Next
End Sub



' ---------------------------------------------------------------------- User Interface Components
Dim WithEvents Button1 As Button = New Button
Dim WithEvents Button2 As Button = New Button
Dim WithEvents Form1 As Form
Dim Label1 As Label = New Label
Dim LabelArray(-1) As Label


Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - " & AppName
	Form1.FormBorderStyle = FormBorderStyle.Fixed3D
	Form1.Size = New Size(600, 440)
	Form1.BackColor = ColorFormBack
	Form1.KeyPreview = True
	Form1.text = ""
	If FormMaximized Then 
		Form1.MaximizeBox = False
		Form1.WindowState = FormWindowState.Maximized
		Form1.ControlBox = False
	Else
		Form1.MaximizeBox = True
		Form1.WindowState = FormWindowState.Normal
		Form1.ControlBox = True
	End If
	Form1.Show
	' ------------------------------------------------------------------ Labels
	ReDim LabelArray(NumButtons - 1)
	InitializeLabels
	Dim x As Int32 = LabelArray(NumButtons - 1).right
	Dim y As Int32 = LabelArray(NumButtons - 1).bottom
	' ------------------------------------------------------------------ Button 1
	Button1.BackColor = ColorBack
	Button1.ForeColor = ColorText
	Button1.Size = New Size(200, 60)
	Button1.Location = New Point(8, Form1.clientsize.height - Button1.height - 16)
	Button1.Font = New Font("Arial", 16)
	Button1.Text = "Stop GCode and rewind"
	Button1.TabStop = False
	Button1.FlatStyle = FlatStyle.System
	Form1.Controls.Add(Button1)
	' ------------------------------------------------------------------ Button 2
	Button2.BackColor = ColorBack
	Button2.ForeColor = ColorText
	Button2.Size = New Size(200, 60)
	Button2.Location = New Point(Button1.width + 12, Form1.clientsize.height - Button2.height - 16)
	Button2.Font = New Font("Arial", 16)
	Button2.Text = "Exit"
	Button2.TabStop = False
	Button2.FlatStyle = FlatStyle.System
	Form1.Controls.Add(Button2)
	' ------------------------------------------------------------------ Form Show
	Form1.ResumeLayout
	Form1.PerformLayout()
	ReleaseAllButtons
End Sub

Sub InitializeLabels()
	Dim LabelSizeX As Int32 = (Form1.ClientSize.Width-24) \ LabelsPerRow
	For i As Int32 = 0 To LabelArray.Length - 1
		LabelArray(i) = New Label
		Form1.Controls.Add(LabelArray(i))
		With LabelArray(i)
			.ForeColor = ColorText
			.BackColor = ColorBack
			.BorderStyle = BorderStyle.Fixed3D
			.Size = New Size(LabelSizeX, LabelSizeY)
			.Location = New Point(10 + (LabelSizeX + 2) * (i Mod LabelsPerRow), _
								10 + (LabelSizeY + 2) * (i \ LabelsPerRow))
			.Font = New Font("Arial", 16)
			.Text = (i + 1).tostring
			.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
			Addhandler .Click, AddressOf ClickHandler
		End With
	Next
	LabelArray(0).Text = "GCode 1"
	LabelArray(1).Text = "GCode 2"
	LabelArray(2).Text = "GCode 3"
	LabelArray(3).Text = "GCode 4"
	LabelArray(4).Text = "GCode 5"
	LabelArray(5).Text = "GCode 6"
	LabelArray(6).Text = "GCode 7"
	LabelArray(7).Text = "GCode 8"
End Sub
















