' ================================================================================================
'  Theremino System SLOTS operations - LED BLINK
' ================================================================================================


' ------------------------------------------------------------------------------------------------
' This function is executed in a separate Thread - Do here slow and paused operations
' Questa funzione e' eseguita in un thread separato - Far qui le operazioni lente o con pause
' ------------------------------------------------------------------------------------------------ 
Sub PausableExecution()

	Label1.Text = "Eseguo 800 passi in un verso e 800 passi in senso inverso (4 giri)."  

	WriteSlot(2, 1000) 					' Imposto il verso di rotazione
	WriteSlot(3, 1000) 					' Accendo il LED CW
	WriteSlot(4, 0) 					' Spengo il LED CCW
	
	For i1 As Int32 = 1 to 800			' Eseguo i 800 pulse per 800 passi
		PausaMS(4)						' duty cycle 50%
		WriteSlot(1, 1000)
		PausaMS(4)
		WriteSlot(1, 0)
	Next
	
	WriteSlot(2, 0) 					' Imposto il verso di opposto al precedente
	WriteSlot(3, 0) 					' Accendo il LED CW
	WriteSlot(4, 1000) 					' Spengo il LED CCW

	For i1 As Int32 = 1 to 800			' Eseguo 800 pulse per 800 passi
		PausaMS(4)						' duty cycle 50%
		WriteSlot(1, 1000)
		PausaMS(4)
		WriteSlot(1, 0)
	Next

	Label2.Text = "Fine ciclo. Attendo 1 sec prima di ripartire"
	WriteSlot(3, 0)						' spengo tutti e due i LED
	WriteSlot(4, 0)

	PausaMS(1000)
	Label2.Text = "Ciclo in esecuzione"

End Sub


' ------------------------------------------------------------------------------------------------
' This function is executed 20 times per second (no pauses here or the whole program is locked)
' Funzione eseguita 20 volte al sec. (niente pause qui altrimenti tutto il programma si blocca)
' ------------------------------------------------------------------------------------------------
Sub FastExecution

End Sub




' ------------------------------------------------------------------------------------------------
'  Functions called from user controls events
'  Queste funzioni vengono chiamate dagli eventi causati dai controlli utente
' ------------------------------------------------------------------------------------------------
Sub TrackBar1_Scroll(value As Single)
	Label2.Text = "E' stato mosso il cursore, il suo valore e': " & value.ToString("0")
	WriteSlot(1, value)
End Sub





' ================================================================================================
'  - ENG - THE SIMPLIFIED MANAGEMENT ENDS HER - MODIFY THE FOLLOWING CAREFULLY
' ------------------------------------------------------------------------------------------------
'  - ITA - LA GESTIONE SEMPLIFICATA FINISCE QUI - MODIFICARE LA PARTE SEGUENTE CON ATTENZIONE
' ================================================================================================


Sub Main(ByVal s() As String)
	if Form1 IsNot Nothing then return
	Form1 = New form
	InitializeComponents
	MemoryMappedFile_Init
	StartThread
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Form1.Closing
	Timer1.Stop
	objThread.Abort
End Sub

Sub StartThread()
	' --------------------------------------------------------- asynchronously start the Thread 
	objThread = New Threading.Thread(AddressOf ExecuteThread)
	' --------------------------------------------------------- make the thread as background thread.
	objThread.IsBackground = True
	' --------------------------------------------------------- set the Priority of the thread.
	objThread.Priority = Threading.ThreadPriority.AboveNormal
	' --------------------------------------------------------- start the thread.
	objThread.Start()
End Sub

Sub ExecuteThread
	Do
		PausableExecution
		PausaMS(1)
	loop until false
End Sub

Sub PausaMS(Byval mS As Int32)
	Threading.Thread.Sleep(mS)
End Sub

Sub Timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles Timer1.Tick
	FastExecution
End Sub

Sub TrackBar1_Scroll(ByVal sender As Object, ByVal e As EventArgs) Handles TrackBar1.Scroll
	TrackBar1_Scroll(TrackBar1.Value)
End Sub

' ---------------------------------------------------------------------- User Interface Components
WithEvents Form1 As Form
WithEvents Timer1 As Timer = New Timer
Dim objThread As Threading.Thread
Dim Label1 As Label = new Label
Dim Label2 As Label = new Label
WithEvents TrackBar1 As TrackBar = new TrackBar

Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - Led BLINK"
	Form1.ClientSize = New System.Drawing.Size(640, 240)
	Form1.MinimumSize = Form1.Size
	Form1.StartPosition = FormStartPosition.CenterScreen
	' ------------------------------------------------------------------ Label 1
	Label1.BorderStyle = BorderStyle.Fixed3D
	Label1.Location = New Point(10, 10)
	Label1.Font = New Font("Arial", 12 )
	Label1.Size = New Size(620, 21)
	Label1.Anchor = AnchorStyles.top or AnchorStyles.Left or AnchorStyles.right
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ Label 2
	Label2.BorderStyle = BorderStyle.Fixed3D
	Label2.Location = New Point(10, 40)
	Label2.Font = New Font("Arial", 12 )
	Label2.Size = New Size(620, 21)
	Label2.Anchor = AnchorStyles.top or AnchorStyles.Left or AnchorStyles.right
	Form1.Controls.Add(Label2)	
	' ------------------------------------------------------------------ TrackBar 1
	TrackBar1.Location = New Point(10, 80)
	TrackBar1.Size = New Size(45, 149)
	TrackBar1.Orientation = Orientation.Vertical
	TrackBar1.TickStyle = TickStyle.Both
	TrackBar1.Maximum = 1000
	TrackBar1.TickFrequency = 100
	TrackBar1.LargeChange = 10
	Form1.Controls.Add(TrackBar1)
	' ------------------------------------------------------------------ Timer 1
	Timer1.Interval = 50
	Timer1.Start
	' ------------------------------------------------------------------ 
	SistemaPrecisoAlMillisecondo
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.show
End Sub


' ===============================================================
'        PRECISIONE TIMERS WINDOWS
' =============================================================== 
<System.Runtime.InteropServices.DllImport("winmm.dll")> _
Private Function timeBeginPeriod(ByVal uPeriod As Int32) As Int32
End Function
<System.Runtime.InteropServices.DllImport("winmm.dll")> _
Private Function timeEndPeriod(ByVal uPeriod As Int32) As Int32
End Function
Private Sub SistemaPrecisoAlMillisecondo()
	timeBeginPeriod(1)
End Sub
Private Sub SistemaNormalePrecisione()
	timeEndPeriod(1)
End Sub

