
' ================================================================================================
'  Theremino System - Radio Waves Attenuations
' ================================================================================================

Sub Form1_load(sender As Object, e As System.EventArgs) Handles Form1.load
	Dim freqMHz As Double
	Dim distKm As Double 
	label1.text &= vbcrlf
	label1.text &= "Lightning detectors attenuations"
	label1.text &= vbcrlf
	freqMHz = 0.3
	PrintAttenuation(0.05, freqMHz)
	PrintAttenuation(0.1, freqMHz)
	PrintAttenuation(0.2, freqMHz)
	PrintAttenuation(0.5, freqMHz)
	PrintAttenuation(1, freqMHz)
	PrintAttenuation(10, freqMHz)
	PrintAttenuation(20, freqMHz)
	PrintAttenuation(50, freqMHz)
	PrintAttenuation(100, freqMHz)
	PrintAttenuation(200, freqMHz)
	PrintAttenuation(500, freqMHz)
	PrintAttenuation(1000, freqMHz)
	label1.text &= vbcrlf
	label1.text &= "Classic 144 MHz test"
	label1.text &= vbcrlf
	freqMHz	= 144
	distKm = 0.001
	For i As Int32 = 1 To 10
		PrintAttenuation(distKm, freqMHz)
		distKm *= 2
	Next
End Sub

Sub PrintAttenuation(Km As Double, MHz As Double) 
	Dim dB As Double = AttenuationDB(Km, MHz)
	Dim s As String = StrDup(50, " ")
	If MHz >= 1 Then
		mid(s,1) = Mhz.ToString("MHz=0")
	Else
		mid(s,1) = (Mhz * 1000).ToString("KHz=0")
	End If
	If Km >= 1 Then
		mid(s,15) = Km.ToString("Km=0")
	Else
		mid(s,15) = (Km * 1000).ToString("m=0")
	End If
	mid(s,30) = dB.ToString("dB=0")
	label1.text += (s + vbcrlf)
End Sub

Function AttenuationDB(Km As Double, MHz As Double) As Double
	AttenuationDB = 32.45 + 20 * Log10(Km) + 20 * Log10(MHz)
	If AttenuationDB < 0 Then AttenuationDB = 0
End Function


' ------------------------------------------------------------------------------------------------
'  Main Loop
' ------------------------------------------------------------------------------------------------
Sub Main(ByVal s() As String)
	If Form1 IsNot Nothing Then Return
	Form1 = New form
	InitializeComponents
	MemoryMappedFile_Init
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Form1.Closing

End Sub

Dim ValidKeyDown As Boolean = True
Sub Form1_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles Form1.KeyDown
	If e.KeyCode = Keys.Space And ValidKeyDown Then
		ValidKeyDown = False

	End If
End Sub
Sub Form1_KeyUp(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles Form1.KeyUp
	If e.KeyCode = Keys.Space Then
		ValidKeyDown = True
	End If
End Sub


' ---------------------------------------------------------------------- User Interface Components
Dim WithEvents Form1 As Form
Dim Label1 As Label = New Label
Dim WithEvents Button1 As Button = New Button

Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - RadioWavesAttenuations"
	Form1.ClientSize = New System.Drawing.Size(480, 600)
	Form1.StartPosition = FormStartPosition.CenterScreen
	Form1.FormBorderStyle = FormBorderStyle.Sizable
	Form1.MaximizeBox = False
	Form1.KeyPreview = True
	' ------------------------------------------------------------------ Label 1
	Label1.BorderStyle = BorderStyle.Fixed3D
	Label1.Location = New Point(8, 8)
	Label1.Width = form1.clientsize.Width-16
	Label1.Height = form1.clientsize.Height-16
	Label1.Font = New Font("Courier New", 10 )
	Label1.Anchor = AnchorStyles.Top Or AnchorStyles.Left Or AnchorStyles.right Or AnchorStyles.bottom
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.Show
End Sub






