
WithEvents Form1 as Form 
WithEvents PictureBox1 As PictureBox = new PictureBox
WithEvents Timer1 As Timer = New Timer

Sub Main(ByVal s() As String)
	if Form1 IsNot Nothing Then Return
	Form1 = New Form
	Form1.Show
	Timer1.Interval = 20
	Timer1.Start
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(1)
	End While
	Timer1.Stop
End Sub

Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Form1.Load
	Form1.Controls.Add(PictureBox1)
	With PictureBox1
		.Width = Form1.Width
		.Height = Form1.Height
		.Anchor = AnchorStyles.Bottom Or AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
	End With
	InitPictureboxImage(PictureBox1)
	Form1.Show
	form1.TopMost = true
End Sub

Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Form1.Resize
	InitPictureboxImage(PictureBox1)
	Test_Circles(PictureBox1)
	Test_Lines(PictureBox1)
	PictureBox1.refresh
End Sub


' ------------------------------------------------------
dim gr as graphics

Sub InitPictureboxImage(ByVal pbox As PictureBox)
	' -------------------------------------------------- NEVER USE "PictureBox.CreateGraphics"
	'gr = pbox.CreateGraphics
	' -------------------------------------------------- THIS IS FASTER / IMAGE IS STATIC / NO FLICKERING
	If pbox.ClientSize.Height < 1 Then Return
	pbox.Image = New Bitmap(pbox.ClientSize.Width, pbox.ClientSize.Height)
	gr = Graphics.FromImage(pbox.Image)
End Sub



Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
	Test_Circles(PictureBox1)
	Test_Lines(PictureBox1)
	PictureBox1.refresh
End Sub



' ------------------------------------------------------
'	Test Lines
' ------------------------------------------------------

Sub Test_Lines(ByVal pbox As PictureBox)

	Dim div As Double = 64
	Dim x1 As Double
	Dim y1 As Double
	Dim x2 As Double
	Dim y2 As Double
	Dim x3 As Double
	Dim y3 As Double
	Dim x4 As Double
	Dim y4 As Double
	Dim dx1 As Double
	Dim dx2 As Double
	Dim dy1 As Double
	Dim dy2 As Double
	Dim f As Double

	Dim w As int32 = pbox.width
	Dim h As int32 = pbox.Height

	for i as int32 = 1 to 10
		dim p as pen = new pen(color.fromargb(cint(rnd*255),cint(rnd*255), cint(rnd*255)))

		dx1 = w * Rnd: dy1 = h * Rnd
		dx2 = w * Rnd: dy2 = h * Rnd
		x3 = ((dx1 - x1) / div): y3 = ((dy1 - y1) / div)
		x4 = ((dx2 - x2) / div): y4 = ((dy2 - y2) / div)
		For f = 1 To 80
			x1 = x1 + x3: y1 = y1 + y3
			x2 = x2 + x4: y2 = y2 + y4
			gr.drawLine (p, cint(x1), cint(y1), cint(x2), cint(y2))
		Next
	next
End Sub

' ------------------------------------------------------
'	Test Circles
' ------------------------------------------------------

Sub Test_Circles(byval pbox as PictureBox)

	Dim r As Int32
	Dim x As Int32
	Dim y As Int32
	Dim b As SolidBrush
	Dim cr As Int32
	Dim cg As Int32
	Dim cb As Int32
	Dim w As int32 = pbox.width
	Dim h As int32 = pbox.Height

	For i As Int32 = 1 To 40
		r = CInt(20 + 40 * Rnd())
		x = CInt(w * Rnd())
		y = CInt(h * Rnd())
		cr = CInt(50 + 70 * Rnd())
		cg = CInt(50 + 70 * Rnd())
		cb = CInt(50 + 70 * Rnd())

		For r2 As Int32 = r To 1 Step -1
			b = New SolidBrush(Color.FromArgb(cr, cg, cb))
			gr.FillEllipse(b, x - r2 \ 3, y - r2 \ 3, r2, r2)
			cr = min(cr + 5, 255)
			cg = min(cg + 4, 255)
			cb = min(cb + 4, 255)
		Next
	Next
End Sub

