
WithEvents Form1 As Form 
WithEvents PictureBox1 As PictureBox = New PictureBox

Sub Main(ByVal s() As String)
	If Form1 IsNot Nothing Then Return
	Form1 = New Form
	form1.StartPosition = formstartposition.CenterScreen
	form1.width = 800
	form1.height = 600
	Form1.Show
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(1)
	End While
End Sub

Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Form1.Load
	Form1.Controls.Add(PictureBox1)
	With PictureBox1
		.Width = Form1.clientsize.Width
		.Height = Form1.clientsize.Height
		.Anchor = AnchorStyles.Bottom Or AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
	End With
	InitPictureboxImage(PictureBox1)
	DrawProtractor(PictureBox1)
	Form1.Show
	form1.TopMost = True
End Sub

Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Form1.Resize
	InitPictureboxImage(PictureBox1)
	DrawProtractor(PictureBox1)
	PictureBox1.refresh
End Sub


Dim gr As graphics

Sub InitPictureboxImage(ByVal pbox As PictureBox)
	' -------------------------------------------------- NEVER USE "PictureBox.CreateGraphics"
	'gr = pbox.CreateGraphics
	' -------------------------------------------------- THIS IS FASTER / IMAGE IS STATIC / NO FLICKERING
	If pbox.ClientSize.Height < 1 Then Return
	pbox.Image = New Bitmap(pbox.ClientSize.Width, pbox.ClientSize.Height)
	gr = Graphics.FromImage(pbox.Image)
End Sub

' ------------------------------------------------------
'	Draw Stepper Motor Protractor
' ------------------------------------------------------
Sub DrawProtractor(ByVal pbox As PictureBox)
	
	Dim steps As Int32 = 200

	Dim angle As Single
	Dim w As Single = pbox.clientsize.width
	Dim h As Single = pbox.clientsize.Height
	Dim w2 As Single = w/2
	Dim h2 As Single = h/2
	Dim radians As Single
	Dim diam As Single = math.min(w,h)
	Dim r5 As Single = diam * 0.48f
	Dim r4 As Single = diam * 0.46f
	Dim r3 As Single = diam * 0.44f
	Dim r2 As Single = diam * 0.40f
	Dim r1 As Single = diam * 0.37f
	Dim r0 As Single = diam * 0.05f
	Dim x0,y0,x1,y1,x2,y2,x3,y3,x4,y4,x5,y5 As Single
	Dim f As font = New font("arial", 12, fontstyle.Regular)
	
	gr.InterpolationMode = drawing2d.InterpolationMode.HighQualityBicubic
	gr.SmoothingMode = drawing2d.smoothingmode.HighQuality
	
	gr.clear(color.white)
	gr.FillEllipse(New SolidBrush(Color.fromargb(255,255,240)), _
					w2-r3, h2-r3, r3 * 2, r3 * 2)
					
	gr.DrawEllipse(New pen(Color.fromargb(100,100,100)), _
					w2-r0, h2-r0, r0 * 2, r0 * 2)
			
	For StepNumber As Int32 = 0 To steps
		angle = (steps-stepnumber) * 360f / steps
		radians =  CSng(pi * angle / 180)
		x0 = CSng(w2 + r0 * sin(radians))
		y0 = CSng(h2 + r0 * cos(radians))
		x1 = CSng(w2 + r1 * sin(radians))
		y1 = CSng(h2 + r1 * cos(radians))
		x2 = CSng(w2 + r2 * sin(radians))
		y2 = CSng(h2 + r2 * cos(radians))
		x3 = CSng(w2 + r3 * sin(radians))
		y3 = CSng(h2 + r3 * cos(radians))
		x4 = CSng(w2 + r4 * sin(radians))
		y4 = CSng(h2 + r4 * cos(radians))
		x5 = CSng(w2 + r5 * sin(radians))
		y5 = CSng(h2 + r5 * cos(radians))
		
		If Stepnumber Mod 10 = 0  Then
			gr.drawLine(New pen(color.fromargb(200,225,200), 1), x0, y0, x1, y1)
			gr.drawLine(New pen(color.fromargb(85,85,85), 2), x3, y3, x5, y5)
			If Stepnumber <> 0 And stepnumber < steps Then
				gr.DrawString(stepnumber.tostring, f,New SolidBrush(Color.fromargb(55,55,40)), x2 - 14, y2 - 8)
			End If
		Else
			gr.drawLine(New pen(color.fromargb(85,85,85), 2), x4, y4, x5, y5)
		End If
	Next
End Sub


